import { AutoMap } from '@automapper/classes';
import { Frequency } from '../types/frequency.enum';
import { Address } from '../entities/address';

export class AdCreation {
  @AutoMap()
  uuid: string;

  @AutoMap()
  userUuid: string;

  @AutoMap()
  driver: boolean;

  @AutoMap()
  passenger: boolean;

  @AutoMap()
  frequency: Frequency;

  @AutoMap()
  fromDate: Date;

  @AutoMap()
  toDate: Date;

  @AutoMap()
  monTime?: string;

  @AutoMap()
  tueTime?: string;

  @AutoMap()
  wedTime?: string;

  @AutoMap()
  thuTime?: string;

  @AutoMap()
  friTime?: string;

  @AutoMap()
  satTime?: string;

  @AutoMap()
  sunTime?: string;

  @AutoMap()
  monMargin: number;

  @AutoMap()
  tueMargin: number;

  @AutoMap()
  wedMargin: number;

  @AutoMap()
  thuMargin: number;

  @AutoMap()
  friMargin: number;

  @AutoMap()
  satMargin: number;

  @AutoMap()
  sunMargin: number;

  @AutoMap()
  seatsDriver: number;

  @AutoMap()
  seatsPassenger: number;

  @AutoMap()
  strict: boolean;

  @AutoMap()
  createdAt: Date;

  @AutoMap()
  updatedAt?: Date;

  @AutoMap()
  addresses: { create: Address[] };
}
