import {
  ValidateBy,
  ValidationArguments,
  ValidationOptions,
  buildMessage,
} from 'class-validator';
import { isPunctualOrRecurrent } from '../is-punctual-or-recurrent';

export const IsPunctualOrRecurrent = (
  validationOptions?: ValidationOptions,
): PropertyDecorator =>
  ValidateBy(
    {
      name: '',
      constraints: [],
      validator: {
        validate: (value, args: ValidationArguments): boolean =>
          isPunctualOrRecurrent(args),
        defaultMessage: buildMessage(
          () =>
            `the departure Date and time , from date, to date and schedule must be properly set on recurrent or punctual ad`,
          validationOptions,
        ),
      },
    },
    validationOptions,
  );
