import { CreateAdRequest } from '../dtos/create-ad.request';
import { Day } from '../types/day.enum';

import { Frequency } from '../types/frequency.enum';

export class FrequencyNormaliser {
  fromDateResolver(createAdRequest: CreateAdRequest): Date {
    if (createAdRequest.frequency === Frequency.PUNCTUAL)
      return createAdRequest.departureDateTime;
    return createAdRequest.fromDate;
  }
  toDateResolver(createAdRequest: CreateAdRequest): Date {
    if (createAdRequest.frequency === Frequency.PUNCTUAL)
      return createAdRequest.departureDateTime;
    return createAdRequest.toDate;
  }
  scheduleResolver = (
    createAdRequest: CreateAdRequest,
    day: number,
  ): string => {
    if (
      Object.keys(createAdRequest.schedule).length === 0 &&
      createAdRequest.frequency == Frequency.PUNCTUAL &&
      createAdRequest.departureDateTime.getDay() === day
    )
      return `${createAdRequest.departureDateTime
        .getHours()
        .toString()
        .padStart(2, '0')}:${createAdRequest.departureDateTime
        .getMinutes()
        .toString()
        .padStart(2, '0')}`;
    return createAdRequest.schedule[Day[day]];
  };
}
